#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "ipow.h"

static int findoverflow(int b) {
	int e, p, q = -1;
	if (b <= 1) {
		return 0;
	}
	for (e = 0;; e++) {
		p = ipow(b, e);
		if (p < q) {
			return e;
		}
		printf("ipow(%d,%d): %d\n", b, e, p);
		q = p;
	}
}

static int findarg(int argc, char** argv, char const* arg) {
	int i;
	for (i = 1; i < argc; i++) {
		if (strcmp(argv[i], arg) == 0 && i + 1 < argc) {
			return (int)atof(argv[i + 1]);
		}
	}
	return 0;
}

static void run(int b, int e, int i) {
	for (; i != 0; i--) {
		ipow(b, e);
	}
}

int main(int argc, char** argv) {
	int b, f, e, i;
	double o;
	b = findarg(argc, argv, "-b");
	b = (b == 0 ? 3 : b);
	o = (8 * sizeof (b) - 1) / (log(b) / log(2));
	printf("expected overflow after %g\n", o);
	f = findoverflow(b) - 1;
	printf("found overflow after %d\n", f);
	f = (f > o ? (int)o : f);
	printf("will overflow after %d\n", f);
	e = findarg(argc, argv, "-e");
	e = (e == 0 ? f : e);
	i = findarg(argc, argv, "-i");
	i = (i == 0 ? (int)1e9 : i);
	printf("%d (%g) iterations\n", i, (double)i);
	run(b, e, i);
	printf("done\n");
	return 0;
}
